import ease from 'rx-ease';
import { BehaviorSubject, Observable, combineLatest, from, of } from 'rxjs';
import { map } from 'rxjs/operators';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};



















var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};





















var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();













var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var compose = function compose() {
  for (var _len = arguments.length, fns = Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function (x) {
    return fns.reduceRight(function (value, f) {
      return f(value);
    }, x);
  };
};



var curry = function curry(f) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return args.length >= f.length ? f.apply(undefined, args) : function () {
      for (var _len4 = arguments.length, args2 = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args2[_key4] = arguments[_key4];
      }

      return curry(f).apply(undefined, args.concat(args2));
    };
  };
};

var mapValues = curry(function (f, obj) {
  return Object.keys(obj).reduce(function (acc, k) {
    return _extends({}, acc, defineProperty({}, k, f(obj[k], k)));
  }, {});
});

var isObject = function isObject(x) {
  return (typeof x === 'undefined' ? 'undefined' : _typeof(x)) === 'object' && x !== null;
};

function _objectValues(obj) {
  var values = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) values.push(obj[keys[k]]);

  return values;
}

function _objectValues(obj) {
  var values = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) values.push(obj[keys[k]]);

  return values;
}

var isPromise = function isPromise(p) {
  return p && typeof p.then === 'function';
};

var isObservable = function isObservable(x) {
  return x && typeof x.subscribe === 'function';
};

var toObservable = function toObservable(x) {
  return isObservable(x) ? x : of(x);
};

var switchMap = curry(function (switchMapper, stream) {
  var subscription = void 0;

  return new Observable(function (observer) {
    var isOuterStreamComplete = false;
    var isInnerStreamComplete = false;

    var sub = stream.subscribe({
      next: function next(x) {
        if (subscription) subscription.unsubscribe();
        subscription = switchMapper(x).subscribe({
          error: function error(e) {
            return observer.error(e);
          },
          next: function next(x) {
            return observer.next(x);
          },
          complete: function complete() {
            isInnerStreamComplete = true;
            if (isOuterStreamComplete) observer.complete();
          }
        });
      },
      error: function error(e) {
        return observer.error(e);
      },
      complete: function complete() {
        isOuterStreamComplete = true;
        if (isInnerStreamComplete) observer.complete();
      }
    });

    return {
      unsubscribe: function unsubscribe() {
        if (subscription) subscription.unsubscribe();
        sub.unsubscribe();
      }
    };
  });
});

// all :: [Observable a] -> Observable [a]
var all = function all(obs) {
  return obs.length ? combineLatest.apply(undefined, toConsumableArray(obs.map(toObservable)).concat([function () {
    for (var _len = arguments.length, xs = Array(_len), _key = 0; _key < _len; _key++) {
      xs[_key] = arguments[_key];
    }

    return xs;
  }])) : of([]);
};

// combineLatestObject :: Object (Observable a) -> Observable (Object a)
var combineLatestObject = function combineLatestObject(obj) {
  var keys = Object.keys(obj);
  return keys.length ? combineLatest.apply(undefined, toConsumableArray(keys.map(function (k) {
    return toObservable(obj[k]).pipe(map(function (v) {
      return [k, v];
    }));
  })).concat([function () {
    for (var _len2 = arguments.length, entries = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      entries[_key2] = arguments[_key2];
    }

    return entries.reduce(function (acc, _ref) {
      var _ref2 = slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      return _extends({}, acc, defineProperty({}, k, v));
    }, {});
  }])) : of(obj);
};





var raf = new Observable(function (observer) {
  var isSubscribed = true;

  var loop = function loop() {
    if (isSubscribed) {
      observer.next();
      window.requestAnimationFrame(loop);
    }
  };

  window.requestAnimationFrame(loop);

  return {
    unsubscribe: function unsubscribe() {
      isSubscribed = false;
    }
  };
});

var applyIf = curry(function (predicate, f, v) {
  return predicate(v) ? f(v) : v;
});

var ifObservable = applyIf(isObservable);

var allIfObservable = applyIf(function (obs) {
  return obs.some(isObservable);
}, all);

var combineLatestObjectIfObservable = applyIf(function (obj) {
  return _objectValues(obj).some(isObservable);
}, combineLatestObject);

var defaultWith = function defaultWith(value) {
  var delayMs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 32;
  return function (stream) {
    return new Observable(function (observer) {
      var timeout = setTimeout(function () {
        return observer.next(value);
      }, delayMs);
      return stream.subscribe({
        next: function next(x) {
          clearTimeout(timeout);
          observer.next(x);
        },
        complete: function complete() {
          clearTimeout(timeout);
          observer.complete();
        },
        error: function error(e) {
          clearTimeout(timeout);
          observer.error(e);
        }
      });
    });
  };
};

var _flip = function _flip(ds) {
  return isObservable(ds) ? switchMap(compose(toObservable, _flip))(ds) : isPromise(ds) ? switchMap(compose(toObservable, _flip))(from(ds)) : Array.isArray(ds) ? allIfObservable(ds.map(compose(ifObservable(defaultWith(undefined)), _flip))) : isObject(ds) ? ds.type === 'Component' ? ds : combineLatestObjectIfObservable(mapValues(compose(ifObservable(defaultWith(undefined)), _flip), ds)) : ds;
};

var flip = function flip(ds) {
  return toObservable(_flip(ds));
};

var createMutable = function createMutable(initialValue) {
  var sub = new BehaviorSubject(initialValue);
  sub.set = function (x) {
    return sub.next(typeof x === 'function' ? x(sub.value) : x);
  };
  return sub;
};

function createState(initialState) {
  return mapValues(createMutable, initialState);
}

export { ease, createState, all, flip };
