import createTag from 'vdom-tag';
import { BehaviorSubject, Observable, combineLatest, from, of } from 'rxjs';
import { filter, map, share, shareReplay, startWith } from 'rxjs/operators';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};





















var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();











var toArray = function (arr) {
  return Array.isArray(arr) ? arr : Array.from(arr);
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var compose = function compose() {
  for (var _len = arguments.length, fns = Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function (x) {
    return fns.reduceRight(function (value, f) {
      return f(value);
    }, x);
  };
};



var curry = function curry(f) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return args.length >= f.length ? f.apply(undefined, args) : function () {
      for (var _len4 = arguments.length, args2 = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args2[_key4] = arguments[_key4];
      }

      return curry(f).apply(undefined, args.concat(args2));
    };
  };
};

function _objectEntries(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

function _objectEntries(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

var fromEntries = function fromEntries(entries) {
  return entries.reduce(function (acc, _ref) {
    var _ref2 = slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    return _extends({}, acc, defineProperty({}, key, value));
  }, {});
};

var pickBy = curry(function (predicate, obj) {
  return fromEntries(_objectEntries(obj).filter(function (_ref3) {
    var _ref4 = slicedToArray(_ref3, 2),
        key = _ref4[0],
        value = _ref4[1];

    return predicate(value, key);
  }));
});



var mapValues = curry(function (f, obj) {
  return Object.keys(obj).reduce(function (acc, k) {
    return _extends({}, acc, defineProperty({}, k, f(obj[k], k)));
  }, {});
});

var isObject = function isObject(x) {
  return (typeof x === 'undefined' ? 'undefined' : _typeof(x)) === 'object' && x !== null;
};

function _objectValues(obj) {
  var values = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) values.push(obj[keys[k]]);

  return values;
}

function _objectValues(obj) {
  var values = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) values.push(obj[keys[k]]);

  return values;
}

var isPromise = function isPromise(p) {
  return p && typeof p.then === 'function';
};

var isObservable = function isObservable(x) {
  return x && typeof x.subscribe === 'function';
};

var toObservable = function toObservable(x) {
  return isObservable(x) ? x : of(x);
};

var switchMap = curry(function (switchMapper, stream) {
  var subscription = void 0;

  return new Observable(function (observer) {
    var isOuterStreamComplete = false;
    var isInnerStreamComplete = false;

    var sub = stream.subscribe({
      next: function next(x) {
        if (subscription) subscription.unsubscribe();
        subscription = switchMapper(x).subscribe({
          error: function error(e) {
            return observer.error(e);
          },
          next: function next(x) {
            return observer.next(x);
          },
          complete: function complete() {
            isInnerStreamComplete = true;
            if (isOuterStreamComplete) observer.complete();
          }
        });
      },
      error: function error(e) {
        return observer.error(e);
      },
      complete: function complete() {
        isOuterStreamComplete = true;
        if (isInnerStreamComplete) observer.complete();
      }
    });

    return {
      unsubscribe: function unsubscribe() {
        if (subscription) subscription.unsubscribe();
        sub.unsubscribe();
      }
    };
  });
});

// all :: [Observable a] -> Observable [a]
var all = function all(obs) {
  return obs.length ? combineLatest.apply(undefined, toConsumableArray(obs.map(toObservable)).concat([function () {
    for (var _len = arguments.length, xs = Array(_len), _key = 0; _key < _len; _key++) {
      xs[_key] = arguments[_key];
    }

    return xs;
  }])) : of([]);
};

// combineLatestObject :: Object (Observable a) -> Observable (Object a)
var combineLatestObject = function combineLatestObject(obj) {
  var keys = Object.keys(obj);
  return keys.length ? combineLatest.apply(undefined, toConsumableArray(keys.map(function (k) {
    return toObservable(obj[k]).pipe(map(function (v) {
      return [k, v];
    }));
  })).concat([function () {
    for (var _len2 = arguments.length, entries = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      entries[_key2] = arguments[_key2];
    }

    return entries.reduce(function (acc, _ref) {
      var _ref2 = slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      return _extends({}, acc, defineProperty({}, k, v));
    }, {});
  }])) : of(obj);
};

var blockComplete = function blockComplete() {
  return function (stream) {
    return new Observable(function (observer) {
      return stream.subscribe({
        complete: function complete() {},
        next: function next(x) {
          return observer.next(x);
        },
        error: function error(e) {
          return observer.error(e);
        }
      });
    });
  };
};

var sample = curry(function (sampleStream, stream) {
  var none = Symbol('None');
  return new Observable(function (observer) {
    var latestValue = none;
    var sub = stream.subscribe({
      next: function next(value) {
        latestValue = value;
      },
      complete: function complete() {},
      error: function error(e) {
        return observer.error(e);
      }
    });

    var sampleSub = sampleStream.subscribe({
      next: function next() {
        if (latestValue !== none) {
          observer.next(latestValue);
          latestValue = none;
        }
      },
      complete: function complete() {
        return observer.complete();
      },
      error: function error(e) {
        return observer.error(e);
      }
    });

    return {
      unsubscribe: function unsubscribe() {
        sub.unsubscribe();
        sampleSub.unsubscribe();
      }
    };
  });
});

var raf = new Observable(function (observer) {
  var isSubscribed = true;

  var loop = function loop() {
    if (isSubscribed) {
      observer.next();
      window.requestAnimationFrame(loop);
    }
  };

  window.requestAnimationFrame(loop);

  return {
    unsubscribe: function unsubscribe() {
      isSubscribed = false;
    }
  };
});

var applyIf = curry(function (predicate, f, v) {
  return predicate(v) ? f(v) : v;
});

var ifObservable = applyIf(isObservable);

var allIfObservable = applyIf(function (obs) {
  return obs.some(isObservable);
}, all);

var combineLatestObjectIfObservable = applyIf(function (obj) {
  return _objectValues(obj).some(isObservable);
}, combineLatestObject);

var defaultWith = function defaultWith(value) {
  var delayMs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 32;
  return function (stream) {
    return new Observable(function (observer) {
      var timeout = setTimeout(function () {
        return observer.next(value);
      }, delayMs);
      return stream.subscribe({
        next: function next(x) {
          clearTimeout(timeout);
          observer.next(x);
        },
        complete: function complete() {
          clearTimeout(timeout);
          observer.complete();
        },
        error: function error(e) {
          clearTimeout(timeout);
          observer.error(e);
        }
      });
    });
  };
};

var _flip = function _flip(ds) {
  return isObservable(ds) ? switchMap(compose(toObservable, _flip))(ds) : isPromise(ds) ? switchMap(compose(toObservable, _flip))(from(ds)) : Array.isArray(ds) ? allIfObservable(ds.map(compose(ifObservable(defaultWith(undefined)), _flip))) : isObject(ds) ? ds.type === 'Component' ? ds : combineLatestObjectIfObservable(mapValues(compose(ifObservable(defaultWith(undefined)), _flip), ds)) : ds;
};

var flip = function flip(ds) {
  return toObservable(_flip(ds));
};

var noOp = function noOp() {};

var createDefaultLifecycle = function createDefaultLifecycle() {
  return {
    mount: noOp,
    update: noOp,
    unmount: noOp
  };
};

var isEmpty = function isEmpty(x) {
  return x !== 0 && (!x || typeof x === 'string' && !x.trim()) || Array.isArray(x) && !x.length;
};

var hasContent = function hasContent(xs) {
  return !xs.length || !xs.every(isEmpty);
};

// data Variable a
//   = a
//   | Promise (Variable a)
//   | Observable (Variable a)
//   | [Variable a]

// flatten :: Variable a -> Observable a
var flatten = function flatten(variable) {
  return Array.isArray(variable) ? all(variable.map(compose(startWith(''), flatten))).pipe(filter(hasContent)) : isObservable(variable) ? switchMap(flatten, variable) : isPromise(variable) ? switchMap(flatten, from(variable)) : toObservable(variable);
};

var sharedRaf = share()(raf);

// createReactiveTag
//  :: ([String] -> ...[Variable a] -> b)
//  -> [String]
//  -> ...[Variable a]
//  -> Observable b
var createReactiveTag = function createReactiveTag(tagFunction) {
  return function (strings) {
    for (var _len = arguments.length, variables = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      variables[_key - 1] = arguments[_key];
    }

    return flatten(variables).pipe(blockComplete(), startWith([]), sample(sharedRaf), map(function (variables) {
      return tagFunction.apply(undefined, [strings].concat(toConsumableArray(variables)));
    }));
  };
};

var flatMap = curry(function (f, xs) {
  return xs.reduce(function (acc, x) {
    return acc.concat(f(x));
  }, []);
});

var flatten$1 = flatMap(function (x) {
  return x;
});

function _objectEntries$1(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

function _objectEntries$1(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

var sharedRaf$1 = share()(raf);

var toStream = function toStream(component) {
  return flip(component).pipe(sample(sharedRaf$1));
};

// type Style = Map 'style' (Map String (String | Observable String))
//
// type Attr = (Map String (String | Observable String)) | Style
//
// type Props = Map String a
//
// data Tree
//   = VNode {
//     attrs :: Attr,
//     children :: [Tree]
//   }
//   | VText { text :: String | Observable String }
//   | Component { name :: (Observable Props -> Observable Tree) }
//   | [Tree]
//   | Observable Tree

// render :: Tree -> DOMElement -> ()
var render = function render(initialVTree, element) {
  var context = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _ref = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {},
      _ref$isSvg = _ref.isSvg,
      isSvg = _ref$isSvg === undefined ? false : _ref$isSvg,
      _ref$morphNode = _ref.morphNode,
      morphNode = _ref$morphNode === undefined ? false : _ref$morphNode;

  var rootNode = morphNode ? element : element.firstChild;
  var previousTree = void 0;

  var component = typeof initialVTree === 'function' ? initialVTree(context) : initialVTree;

  var sub = toStream(component).subscribe({
    next: function next(vTree) {
      if (vTree.type === 'VPatch') {
        previousTree = vTree.vTree;
      } else if (Array.isArray(vTree)) {
        if (!rootNode) {
          rootNode = element;
          updateChildren(rootNode, previousTree || [], vTree, isSvg, context);
        } else {
          updateChildren(rootNode, previousTree || [], vTree, isSvg, context);
        }
        previousTree = vTree;
      } else {
        if (!rootNode) {
          rootNode = _createElement(vTree, isSvg, context);
          element.innerHTML = '';
          element.appendChild(rootNode);
        } else {
          rootNode = patch(rootNode, previousTree, vTree, isSvg, context);
        }
        previousTree = vTree;
      }
    }
  });

  return {
    unsubscribe: function unsubscribe() {
      if (previousTree) _removeElement(previousTree, rootNode);
      sub.unsubscribe();
    }
  };
};

var VText = function () {
  function VText(_ref2) {
    var text = _ref2.text;
    classCallCheck(this, VText);

    this.type = 'VText';
    this.text = text;
  }

  createClass(VText, [{
    key: 'createElement',
    value: function createElement() {
      return document.createTextNode(this.text);
    }
  }, {
    key: 'updateElement',
    value: function updateElement(node, previousText) {
      if (previousText.text !== this.text) node.textContent = this.text;
    }
  }, {
    key: 'removeElement',
    value: function removeElement() {}
  }, {
    key: 'mount',
    value: function mount() {}
  }]);
  return VText;
}();

function isShallowEqual(obj1, obj2) {
  for (var k1 in obj1) {
    if (!(k1 in obj2) || obj1[k1] !== obj2[k1]) return false;
  }

  for (var k2 in obj2) {
    if (!(k2 in obj1) || obj1[k2] !== obj2[k2]) return false;
  }

  return true;
}

var updateStyle = function updateStyle(node) {
  var previousStyle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var nextStyle = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  for (var key in _extends({}, previousStyle, nextStyle)) {
    var style = !nextStyle || !nextStyle[key] ? '' : nextStyle[key];
    if (nextStyle[key] === previousStyle[key]) {
      // no update needed
    } else if (key[0] === '-') {
      node.style.setProperty(key, style);
    } else {
      node.style[key] = style;
    }
  }
};

var updateEvents = function updateEvents(vTree, node, previousEvents) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = _objectEntries$1(vTree.events)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _ref3 = _step.value;

      var _ref4 = slicedToArray(_ref3, 2);

      var eventName = _ref4[0];
      var handler = _ref4[1];

      if (!previousEvents[eventName]) {
        node.addEventListener(eventName, handler);
      } else if (handler !== previousEvents[eventName]) {
        node.removeEventListener(eventName, previousEvents[eventName]);
        node.addEventListener(eventName, handler);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var removedEventsEntries = _objectEntries$1(previousEvents).filter(function (_ref5) {
    var _ref6 = slicedToArray(_ref5, 1),
        key = _ref6[0];

    return !vTree.events[key];
  });

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = removedEventsEntries[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var _ref7 = _step2.value;

      var _ref8 = slicedToArray(_ref7, 2);

      var _eventName = _ref8[0];
      var _handler = _ref8[1];

      node.removeEventListener(_eventName, _handler);
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }
};

var updateAttrs = function updateAttrs(vTree, node, previousAttrs) {
  for (var attrName in _extends({}, previousAttrs, vTree.attrs)) {
    var attrValue = vTree.attrs[attrName];

    if (attrValue === previousAttrs[attrName]) {
      // no update needed
    } else if (!isEmpty(attrValue)) {
      if (attrName === 'style') {
        updateStyle(node, previousAttrs.style, vTree.attrs.style);
      } else if (attrName === 'value' && node.tagName === 'INPUT') {
        node.value = attrValue;
      } else {
        node.setAttribute(attrName, attrValue);
      }
    } else {
      if (attrName === 'value' && node.tagName === 'INPUT') {
        node.value = '';
      } else {
        node.removeAttribute(attrName);
      }
    }
  }
};

var updateChildren = function updateChildren(node, previousChildren, children, isSvg, context) {
  var flatChildren = flatten$1(children);
  var flatPreviousChildren = flatten$1(previousChildren);
  for (var index in flatChildren) {
    var childTree = flatChildren[index];
    var previousChildTree = flatPreviousChildren[index];
    var previousChildNode = node.childNodes[index];

    if (!previousChildNode) {
      var childNode = _createElement(childTree, isSvg, context);
      node.appendChild(childNode);
      _mount(childTree, childNode);
    } else {
      patch(previousChildNode, previousChildTree, childTree, isSvg, context);
    }
  }

  for (var _index in [].slice.call(node.childNodes, flatChildren.length)) {
    var realIndex = parseInt(_index) + flatChildren.length;
    var _childTree = flatPreviousChildren[realIndex];
    var _childNode = node.childNodes[realIndex];
    if (_childNode) {
      _removeElement(_childTree, _childNode);
      _childNode.remove();
    }
  }
};

var VNode = function () {
  function VNode(_ref9) {
    var name = _ref9.name,
        _ref9$attrs = _ref9.attrs,
        attrs = _ref9$attrs === undefined ? {} : _ref9$attrs,
        _ref9$lifecycle = _ref9.lifecycle,
        lifecycle = _ref9$lifecycle === undefined ? {} : _ref9$lifecycle,
        _ref9$events = _ref9.events,
        events = _ref9$events === undefined ? {} : _ref9$events,
        _ref9$children = _ref9.children,
        children = _ref9$children === undefined ? {} : _ref9$children,
        _ref9$key = _ref9.key,
        key = _ref9$key === undefined ? '' : _ref9$key;
    classCallCheck(this, VNode);

    this.type = 'VNode';
    this.name = name;
    this.attrs = attrs;
    this.lifecycle = lifecycle;
    this.events = events;
    this.children = children;
    this.key = key;
  }

  createClass(VNode, [{
    key: 'createElement',
    value: function createElement(isSvg, context) {
      var node = (isSvg = isSvg || this.name === 'svg') ? document.createElementNS('http://www.w3.org/2000/svg', this.name) : document.createElement(this.name);

      updateEvents(this, node, {});
      updateAttrs(this, node, {});
      updateChildren(node, [], this.children, isSvg, context);

      return node;
    }
  }, {
    key: 'updateElement',
    value: function updateElement(node, previousTree, isSvg, context) {
      if (previousTree.name !== this.name) {
        _removeElement(previousTree, node);
        return _createElement(this, isSvg, context);
      } else {
        updateEvents(this, node, previousTree.events);
        updateAttrs(this, node, previousTree.attrs);
        updateChildren(node, previousTree.children, this.children, isSvg, context);

        this.lifecycle.update(node);
      }
    }
  }, {
    key: 'removeElement',
    value: function removeElement(node) {
      flatten$1(this.children).map(function (child, index) {
        return _removeElement(child, node.childNodes[index]);
      });

      this.lifecycle.unmount(node);
    }
  }, {
    key: 'mount',
    value: function mount(node) {
      flatten$1(this.children).map(function (child) {
        return _mount(child);
      });

      this.lifecycle.mount(node);
    }
  }]);
  return VNode;
}();

var VPatch = function () {
  function VPatch(_ref10) {
    var vTree = _ref10.vTree;
    classCallCheck(this, VPatch);

    this.type = 'VPatch';
    this.vTree = vTree;
  }

  createClass(VPatch, [{
    key: 'createElement',
    value: function createElement() {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _createElement.apply(undefined, [this.vTree].concat(args));
    }
  }, {
    key: 'updateElement',
    value: function updateElement() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return _updateElement.apply(undefined, [this.vTree].concat(args));
    }
  }, {
    key: 'removeElement',
    value: function removeElement() {
      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return _removeElement.apply(undefined, [this.vTree].concat(args));
    }
  }, {
    key: 'mount',
    value: function mount() {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return _mount.apply(undefined, [this.vTree].concat(args));
    }
  }]);
  return VPatch;
}();

var pickNonObservables = function pickNonObservables(props) {
  return pickBy(function (_, key) {
    return !/\$$/.test(key);
  }, props);
};

function createPropsStream(props) {
  var sub = new BehaviorSubject(props);
  return {
    next: function next(props) {
      return sub.next(props);
    },
    stream: sub.pipe(switchMap(function (props) {
      return combineLatestObject(pickNonObservables(props)).pipe(map(function (values) {
        return _extends({}, props, values);
      }));
    }), shareReplay(1))
  };
}

var Component = function () {
  function Component(_ref11) {
    var name = _ref11.name,
        untouchedAttributes = _ref11.untouchedAttributes,
        _ref11$key = _ref11.key,
        key = _ref11$key === undefined ? '' : _ref11$key;
    classCallCheck(this, Component);

    this.type = 'Component';
    this.name = name;
    this.untouchedAttributes = untouchedAttributes;
    this.key = key;
  }

  createClass(Component, [{
    key: 'createElement',
    value: function createElement(isSvg, context) {
      var node = isSvg ? document.createElementNS('http://www.w3.org/2000/svg', 'g') : document.createElement('div');

      this.state = {};
      this.state.props = createPropsStream(this.untouchedAttributes);

      var vTree = this.name(this.state.props.stream);

      if (!vTree) throw new Error('Component ' + this.name.name + ' must return a stream!');

      this.state.subscription = render(vTree, node, context, {
        isSvg: isSvg,
        morphNode: true
      });

      return node;
    }
  }, {
    key: 'updateElement',
    value: function updateElement(node, previousComponent, isSvg, context) {
      this.state = previousComponent.state;

      if (previousComponent.name !== this.name) {
        _removeElement(previousComponent, node);
        return _createElement(this, isSvg, context);
      } else {
        if (!isShallowEqual(previousComponent.untouchedAttributes, this.untouchedAttributes)) {
          this.state.props.next(this.untouchedAttributes);
        }
      }
    }
  }, {
    key: 'removeElement',
    value: function removeElement() {
      this.state.subscription.unsubscribe();
    }
  }, {
    key: 'mount',
    value: function mount() {}
  }]);
  return Component;
}();

var classes = {
  VNode: VNode,
  VText: VText,
  Component: Component
};

var _createElement = function _createElement(vTree) {
  for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
    args[_key5 - 1] = arguments[_key5];
  }

  return classes[vTree.type].prototype.createElement.apply(vTree, args);
};

var _mount = function _mount(vTree) {
  for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
    args[_key6 - 1] = arguments[_key6];
  }

  return classes[vTree.type].prototype.mount.apply(vTree, args);
};

var _updateElement = function _updateElement(vTree) {
  for (var _len7 = arguments.length, args = Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
    args[_key7 - 1] = arguments[_key7];
  }

  return classes[vTree.type].prototype.updateElement.apply(vTree, args);
};

var _removeElement = function _removeElement(vTree) {
  for (var _len8 = arguments.length, args = Array(_len8 > 1 ? _len8 - 1 : 0), _key8 = 1; _key8 < _len8; _key8++) {
    args[_key8 - 1] = arguments[_key8];
  }

  return classes[vTree.type].prototype.removeElement.apply(vTree, args);
};

function createVTree(node) {
  return {
    key: 'INIT',
    type: 'VNode',
    name: node.nodeName.toLowerCase(),
    lifecycle: createDefaultLifecycle(),
    events: {},
    attrs: {},
    untouchedAttributes: {},
    children: Array.prototype.map.call(node.childNodes, function (node) {
      return node.nodeType === 3 // Node.TEXT_NODE
      ? { type: 'VText', text: node.nodeValue } : createVTree(node);
    })
  };
}

function patch(node) {
  var previousTree = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : createVTree(node);
  var vTree = arguments[2];
  var isSvg = arguments[3];
  var context = arguments[4];

  if (vTree.type !== previousTree.type || vTree.key !== previousTree.key) {
    _removeElement(previousTree, node);
    var newNode = _createElement(vTree, isSvg, context);
    node.parentNode.replaceChild(newNode, node);
    _mount(vTree, newNode, isSvg);
    return newNode;
  } else {
    var _newNode = _updateElement(vTree, node, previousTree, isSvg, context);
    if (_newNode) {
      node.parentNode.replaceChild(_newNode, node);
      _mount(vTree, _newNode, isSvg);
      return _newNode;
    } else {
      return node;
    }
  }
}

function _objectEntries$2(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

function _objectEntries$2(obj) {
  var entries = [];
  var keys = Object.keys(obj);

  for (var k = 0; k < keys.length; ++k) entries.push([keys[k], obj[keys[k]]]);

  return entries;
}

var isLifecycle = function isLifecycle(key) {
  return ['mount', 'update', 'unmount'].includes(key);
};
var isEvent = function isEvent(key) {
  return !!key.match(/^on/);
};
var toEventName = function toEventName(key) {
  return key.replace(/^on/, '').toLowerCase();
};

var styleToObject = function styleToObject(styleStr) {
  return styleStr.split(';').reduce(function (acc, str) {
    var _str$split = str.split(/:/),
        _str$split2 = toArray(_str$split),
        k = _str$split2[0],
        v = _str$split2.slice(1);

    if (k.trim()) acc[k.trim()] = v.join(':');
    return acc;
  }, {});
};

var formatChildren = flatMap(function (c) {
  return Array.isArray(c) ? formatChildren(c) : isEmpty(c) ? [] : ['VNode', 'VText', 'VPatch', 'Component'].some(function (type) {
    return c.type === type;
  }) ? [c] : isObservable(c) || isPromise(c) ? [{
    type: 'Component',
    name: function AnonymousComponent() {
      return flip(c).pipe(map(function (child) {
        return formatChildren([child]);
      }), map(function (children) {
        return children.length === 1 ? children[0] : children;
      }), filter(function (x) {
        return !isEmpty(x);
      }));
    },
    untouchedAttributes: { children: [] }
  }] : [{ type: 'VText', text: c }];
});

function h(name, _attributes) {
  var attributes = _attributes || {};

  for (var _len = arguments.length, _children = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    _children[_key - 2] = arguments[_key];
  }

  var children = _children.reduce(function (acc, x) {
    return acc.concat(x);
  }, []);

  if (typeof name === 'function') {
    return {
      type: 'Component',
      name: name,
      untouchedAttributes: _extends({}, attributes, { children: children })
    };
  }

  var _Object$entries$reduc = _objectEntries$2(attributes).reduce(function (acc, _ref) {
    var _ref2 = slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    if (key === 'key') {
      acc.key = value;
    } else if (isLifecycle(key) && typeof value === 'function') {
      acc.lifecycle[key] = value;
    } else if (isEvent(key) && typeof value === 'function') {
      acc.events[toEventName(key)] = value;
    } else if (key === 'style') {
      acc.attrs[key] = (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' ? value : styleToObject(value);
    } else {
      acc.attrs[key] = value;
    }
    return acc;
  }, { lifecycle: createDefaultLifecycle(), events: {}, attrs: {} }),
      key = _Object$entries$reduc.key,
      lifecycle = _Object$entries$reduc.lifecycle,
      events = _Object$entries$reduc.events,
      attrs = _Object$entries$reduc.attrs;

  return {
    type: 'VNode',
    name: name,
    attrs: attrs,
    lifecycle: lifecycle,
    events: events,
    children: formatChildren(children),
    key: key
  };
}

var createRenderProcess = function createRenderProcess(vdom$) {
  return new Observable(function (observer) {
    var domNode = void 0;
    var previousTree = void 0;
    var isSvg = void 0;

    return vdom$.subscribe({
      complete: function complete() {
        return observer.complete();
      },
      error: function error(e) {
        return observer.error(e);
      },
      next: function next(vTree) {
        if (!(vTree instanceof VNode)) return observer.next(vTree);

        var onMount = vTree.lifecycle.mount;

        vTree.lifecycle.mount = function (node, _isSvg) {
          domNode = node;
          isSvg = _isSvg;
          onMount(node);
        };

        if (!domNode) {
          observer.next(vTree);
        } else {
          domNode = patch(domNode, previousTree, vTree, isSvg);
          observer.next(new VPatch({ vTree: vTree }));
        }

        previousTree = vTree;
      }
    });
  });
};

var toRenderProcess = function toRenderProcess(tag) {
  return function (strings) {
    for (var _len = arguments.length, variables = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      variables[_key - 1] = arguments[_key];
    }

    return createRenderProcess(tag.apply(undefined, [strings].concat(variables)));
  };
};

// html :: [String] -> ...[Variable a] -> Observable VirtualDOM
var html$1 = toRenderProcess(createReactiveTag(createTag(h)));

// textTag :: [String] -> ...[a] -> String
var textTag = function textTag(strings) {
  for (var _len = arguments.length, variables = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    variables[_key - 1] = arguments[_key];
  }

  return strings.reduce(function (acc, s, i) {
    return acc + s + (variables[i] !== undefined ? variables[i] : '');
  }, '');
};

// text :: [String] -> ...[Variable a] -> Observable String
var text = createReactiveTag(textTag);

export { text, render, h };
export default html$1;
